#include <bits\stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second


struct st {
    vector<ll> se;
    ll sz;

    st(ll n) {
        ll k = 1;
        while (k < n)
            k *= 2;
        sz = k * 2;
        se.assign(sz, -1);
    }

    ll ask(ll u) {
        u += sz / 2;
        ll ans = se[u];
        while (u > 1) {
            u /= 2;
            if (se[u] != -2)
                ans = se[u];
        }
        return ans;
    }

    ll l, r, v;

    void f(ll _l, ll _r, ll _v) {
        l = _l, r = _r, v = _v;
        f0(0, sz / 2, 1);
    }

    void push(ll x) {
        if (se[x] == -2)
            return;
        se[x * 2] = se[x * 2 + 1] = se[x];
        se[x] = -2;
    }

    void f0(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            se[now] = v;
        else if (L >= r || R <= l)
            return;
        else {
            push(now);
            f0(L, (R + L) / 2, now * 2);
            f0((R + L) / 2, R, now * 2 + 1);
        }
    }
};

vector<ll> L, R, P, sz, clr, ans, ans1;
ll maD = 0;
st *st1;

ll ssz(ll u, ll d = 0) {
    if (!u)
        return 0;
    maD = max(maD, d);
    return sz[u] = ssz(L[u], d + 1) + 1 + ssz(R[u], d + 1);
}

void dfs(ll u = 1, ll cnt = 0) {
    if (!u)
        return;
    ans[u] = cnt;
    ll h = st1->ask(u);
    if (h == -1) {
        dfs(L[u], cnt + 1);
        dfs(R[u], cnt + 1);
    } else if (h == 0) {
        dfs(L[u], cnt);
        dfs(R[u], cnt + 1);
    } else {
        dfs(L[u], cnt);
        dfs(R[u], cnt);
    }
}

void dfs1(ll u = 1, ll cnt = 1) {
    if (!u)
        return;
    ans1[u] = cnt;
    dfs1(L[u], cnt);
    dfs1(R[u], sz[L[u]] + cnt);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, q;
    cin >> n >> q;
    L.resize(n + 1);
    R.resize(n + 1);
    P.resize(n + 1);
    sz.resize(n + 1);
    clr.assign(n + 1, -1);
    ans1.resize(n + 1);
    st1 = new st(n + 1);

    for (int i = 0; i < n; ++i) {
        cin >> L[i + 1] >> R[i + 1];
        P[L[i + 1]] = i + 1;
        P[R[i + 1]] = i + 1;
    }

    ssz(1);
    dfs1();

    if ((n <= 5000 && q <= 5000 || maD <= 40)) {
        ll h1, h2, h3, h4;
        for (int i = 0; i < q; ++i) {
            cin >> h1 >> h2;
            if (h1 == 1) {
                cin >> h3 >> h4;
                st1->f(h2, h3 + 1, h4);
            } else {
                ll a = ans1[h2];
                ll h = st1->ask(h2);
                if (h == 0)
                    a += sz[L[h2]];
                else if (h == 1)
                    a += sz[L[h2]] + sz[R[h2]];

                while (h2 != 1) {
                    h3 = h2;
                    h2 = P[h2];

                    h = st1->ask(h2);
                    if (h == -1)
                        a++;
                    else if (h == 0 && R[h2] == h3)
                        a++;
                }

                cout << a << '\n';
            }
        }
    } else {

        ans.resize(n + 1);

        bool ntp = 1;
        ll h1, h2, h3, h4;
        for (int i = 0; i < q; ++i) {
            cin >> h1 >> h2;
            if (h1 == 1) {
                cin >> h3 >> h4;
                st1->f(h2, h3 + 1, h4);
                ntp = 1;
            } else {
                if (ntp) {
                    dfs();
                    ntp = 0;
                }
                ll a = ans1[h2];
                ll h = st1->ask(h2);
                if (h == 0)
                    a += sz[L[h2]];
                else if (h == 1)
                    a += sz[L[h2]] + sz[R[h2]];

                cout << a + ans[h2] << '\n';
            }
        }
    }
}
/*
5 5
3 4
0 0
5 2
0 0
0 0
2 2
1 1 3 1
2 5
1 3 3 0
2 3

*/
/*
5 11
2 0
3 0
4 0
5 0
0 0

2 1
2 2
2 3
2 4
2 5
1 1 5 1
2 1
2 2
2 3
2 4
2 5

*/
/*

*/
/*
Хех.
Предварительно это выглядит как задача на ДД.

Какие вершины находятся раньше текущей в таком обходе?

Из потомков
 Если -1, то никого
 Если в ней 0, то все в левом поддереве
 Если в ней 1, то все в обоих поддеревьях

Как узнавать ответ для не потомков в тупую?

Поднимаемся до корня.

Если мы перешли из левого поддерева
    При -1 ответ увиличивается на 1
    иначе не меняется
Если мы перешли из правого поддерева
    При -1 или 0 ответ увиличивается на 1 + левое поддерево
    иначе просто на левое поддерево

Ну, для каждой вершины для второго типа подъемов можно отдельно сщитать размер левого поддерева и отдельно прибавлять к ответу.
 Тогда нужно узнать сколько сверху подъемов налево в вершину с нулем, а также то, сколько сверху встречается -1.
Ну, и с изменениями.

Окей, пока напишу в тупую.

Зашли подгруппа с маленькими нм и с полным бинарным деревом.

Проблема в том, что нельзя полностью подниматься по дереву.

При наличии в ячейке -1, все значения в поддереве больше на 1.
При 0 то же но только в левом поддереве.
При обратных операциях уменьшается на 1 в тех же поддеревьях.

Есть изначальный ответ.

Вообще, похоже на ХЛД.


*/
/*
Что означает шестая подгруппа?
Вершины на отрезке либо отмеченны, либо нет.
Даются запросы, отметить номера вершин на определенном отрезке номеров.
Также требуется уметь узнавать количество отмеченных вершин среди предков текущей.

Для поиска количества нулей среди родителей по правому переходу,
 можно изменить дерево перенаправив все родительские ребра в первую вершину сверху, в правом поддереве которой мы находимся.



*/
/*
Ну, как хотябы подгруппы решать.
Первая и четвертая зашли.

Первая & - квадрат
Вторая & - каждый раз после запроса в тупую, проходимся ДФСом и для каждой вершины изначально считаем ответ.
Третья & - тоже самое впринципе, но операции ДОшкой.
Четвертая & - высота до лога

Пятая - делаем ДО на эйлеровом обходе и выполняя операцию просто меняем ответы для вершин в поддеревьях.




*/